//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		DataBuffer.h
// ߲:		WC++߲
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:		21-Mar-2005 (AESpɕύX)  RAA (ATMELٳ)
//
// xҰ:		avr@atmel.com
//
// :		DataBuffer׽͕Ȃchar̓IɏՕgp҂ɋ܂B
//				̸׽basic_string`ɊÂ܂B16i`ƕȂ
//				charɏՕԂ̕ϊɊւ@\ǉA@\͊{Ibasic_
//				stringƓłB
//
// ̑:
//=============================================================================

#ifndef DATABUFFER_H
#define DATABUFFER_H

#include "ByteString.h"

class DataBuffer : public ByteString
{
public:
	DataBuffer();
	DataBuffer(const DataBuffer& buffer);
	DataBuffer(const char *hexString);
	DataBuffer(const char *hexString, size_t length);
	DataBuffer(const unsigned char *data, size_t length);
	DataBuffer(size_t size, unsigned char fill = 0);

	~DataBuffer();

	DataBuffer& operator =(const DataBuffer& buffer);
	DataBuffer& operator =(char *rvalue);
	DataBuffer& operator =(const ByteString& string);

	char *toHexString(unsigned int first = 0, int length = -1);
	char *toCHexString(unsigned int first = 0, int length = -1);

private:
	char *hexStringM;	// ް16i\܂ވꎞɏՕ

	void deleteHexString();
	void newHexString(size_t length);
	void parse(const char *hexString, size_t length);
};

#endif // DATABUFFER_H
